﻿using System.ComponentModel;
using System.Drawing;
using System.Drawing.Design;

namespace TestProject
{
    /// <summary>
    /// 방향 에디터
    /// </summary>
    public class DirectionEditor : UITypeEditor
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 페인트 값 지원 여부 구하기 - GetPaintValueSupported(context)

        /// <summary>
        /// 페인트 값 지원 여부 구하기
        /// </summary>
        /// <param name="context">컨텍스트</param>
        /// <returns>페인트 값 지원 여부</returns>
        public override bool GetPaintValueSupported(ITypeDescriptorContext context)
        {
            return true;
        }

        #endregion
        #region 값 페인트 하기 - PaintValue(e)

        /// <summary>
        /// 값 페인트 하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        public override void PaintValue(PaintValueEventArgs e)
        {
            Direction value = (Direction)e.Value;
 
            Image image = null;

            switch(value)
            {
                case Direction.LEFT  : image = Properties.Resources.left;  break;
                case Direction.UP    : image = Properties.Resources.up;    break;
                case Direction.RIGHT : image = Properties.Resources.right; break;
                case Direction.DOWN  : image = Properties.Resources.down;  break;
            }
 
            int x = (e.Bounds.Width - image.Width) / 2 + e.Bounds.X;
            int y = e.Bounds.Y;

            e.Graphics.DrawImage(image, x, y);
        }

        #endregion
    }
}